#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QPainter>

class Rectangle : public QWidget
{
    Q_OBJECT
public:
    Rectangle() : QWidget() {
        setAttribute(Qt::WA_TranslucentBackground);
        setWindowFlags(Qt::FramelessWindowHint);
        setAttribute(Qt::WA_DeleteOnClose);
        setGeometry(0,0,1000,1000);
        show();
    }

    void paintEvent(QPaintEvent* e) {
        QPainter painter(this);
        // draw frame
        painter.drawRect(0,0,width()-1,height()-1);

        // WORKAROUND FOR MAC OS X
//        painter.setCompositionMode(QPainter::CompositionMode_Clear);
//        painter.eraseRect(rect());
//        painter.setCompositionMode(QPainter::CompositionMode_SourceOver);

        // draw rectangle to frame
        painter.drawRect(0,0,rectSize,rectSize);
    }

public Q_SLOTS:
    void resizeRectangle(int v) {
        rectSize = double(v);
        update();
    }

    void resizeWindow(int v) {
        // resizing clears background
        resize(v,v);
    }

private:
    double rectSize;
};

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void closeEvent(QCloseEvent *);

private:
    Ui::MainWindow *ui;
    Rectangle* rectangle;
};

#endif // MAINWINDOW_H
